searchData={"content_type":"text/markdown","items":[{"doc":"Base module containing common utility functions\n\nThis module contains some things used internally that may also be useful\noutside of `AshUUID` itself.","ref":"AshUUID.html","title":"AshUUID","type":"module"},{"doc":"","ref":"AshUUID.html#identify_format/1","title":"AshUUID.identify_format/1","type":"function"},{"doc":"Set default values","ref":"AshUUID.Transformers.BelongsToAttribute.html","title":"AshUUID.Transformers.BelongsToAttribute","type":"module"},{"doc":"","ref":"AshUUID.Transformers.BelongsToAttribute.html#after?/1","title":"AshUUID.Transformers.BelongsToAttribute.after?/1","type":"function"},{"doc":"","ref":"AshUUID.Transformers.BelongsToAttribute.html#after_compile?/0","title":"AshUUID.Transformers.BelongsToAttribute.after_compile?/0","type":"function"},{"doc":"","ref":"AshUUID.Transformers.BelongsToAttribute.html#before?/1","title":"AshUUID.Transformers.BelongsToAttribute.before?/1","type":"function"},{"doc":"","ref":"AshUUID.Transformers.BelongsToAttribute.html#transform/1","title":"AshUUID.Transformers.BelongsToAttribute.transform/1","type":"function"},{"doc":"Set default values","ref":"AshUUID.Transformers.PostgresMigrationDefaults.html","title":"AshUUID.Transformers.PostgresMigrationDefaults","type":"module"},{"doc":"","ref":"AshUUID.Transformers.PostgresMigrationDefaults.html#after?/1","title":"AshUUID.Transformers.PostgresMigrationDefaults.after?/1","type":"function"},{"doc":"","ref":"AshUUID.Transformers.PostgresMigrationDefaults.html#after_compile?/0","title":"AshUUID.Transformers.PostgresMigrationDefaults.after_compile?/0","type":"function"},{"doc":"","ref":"AshUUID.Transformers.PostgresMigrationDefaults.html#before?/1","title":"AshUUID.Transformers.PostgresMigrationDefaults.before?/1","type":"function"},{"doc":"","ref":"AshUUID.Transformers.PostgresMigrationDefaults.html#transform/1","title":"AshUUID.Transformers.PostgresMigrationDefaults.transform/1","type":"function"},{"doc":"UUID\n\n#","ref":"AshUUID.UUID.html","title":"AshUUID.UUID","type":"module"},{"doc":"* `:prefix` (`t:String.t/0`) - Prefix The default value is `\"id\"`.\n\n* `:version` (`t:integer/0`) - Version The default value is `7`.\n\n* `:encoded?` (`t:boolean/0`) - Encoded? The default value is `true`.\n\n* `:prefixed?` (`t:boolean/0`) - Prefixed? The default value is `true`.\n\n* `:migration_default?` (`t:boolean/0`) - Migration default The default value is `false`.\n\n* `:strict?` (`t:boolean/0`) - Strict? The default value is `true`.","ref":"AshUUID.UUID.html#module-constraints","title":"Constraints - AshUUID.UUID","type":"module"},{"doc":"# AshUUID\n\n[![Hex](http://img.shields.io/hexpm/v/ash_uuid.svg?style=flat)](https://hex.pm/packages/ash_uuid)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-purple.svg)](https://hexdocs.pm/ash_uuid)\n[![Build Status](https://img.shields.io/github/actions/workflow/status/zoonect-oss/ash_uuid/ci.yml)](https://github.com/zoonect-oss/ash_uuid)\n[![License](https://img.shields.io/github/license/zoonect-oss/ash_uuid?color=blue)](https://github.com/zoonect-oss/ash_uuid/blob/main/LICENSE.md)\n[![GitHub Stars](https://img.shields.io/github/stars/zoonect-oss/ash_uuid?color=ffd700&label=github&logo=github)](https://github.com/zoonect-oss/ash_uuid/stargazers)","ref":"readme.html","title":"AshUUID","type":"extras"},{"doc":"```elixir\ndef deps do\n  [\n    {:ash_uuid, \"~> 0.7\"},\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - AshUUID","type":"extras"},{"doc":"Adoption:\n\n- add `{:ash_uuid, \"~> 0.7\"}`` to your `mix.exs`` project deps;\n\n- add `AshUUID.PostgresExtension`` to your app Repo's installed_extensions and set AshUUID config `migration_default?: true` if Postgres-side UUIDs generation is needed;\n\n- use the extension in your resources `use Ash.Resource, data_layer: AshPostgres.DataLayer, extensions: [AshUUID]`;\n\n- simply use that for your fields `uuid_attribute :id`.","ref":"readme.html#adoption","title":"Adoption - AshUUID","type":"extras"},{"doc":"### `lib/myapp/repo.ex`:\n\nUsing the PostgresExtension allows postgres-side uuid-v7 generation.\n\n```elixir\n# App: Postgres migration defaults, not required\n`\ndefmodule Myapp.Repo do\n  use AshPostgres.Repo, otp_app: :myapp\n\n  @impl AshPostgres.Repo\n  def installed_extensions do\n    [\"ash-functions\", \"uuid-ossp\", \"citext\", AshUUID.PostgresExtension]\n  end\nend\n```\n\n### `config/config.exs`:\n\n```elixir\n# AshUUID: Your otp_app name, required!\nconfig :ash_uuid, :otp_app, :myapp\n\n# Myapp: Customized defaults, not required\nconfig :myapp, :ash_uuid,\n  version: 7, # default\n  encoded?: true, # default\n  prefixed?: true, # default\n  migration_default?: true, # default to false\n  strict?: true # default to true\n\n# Ash: Type shorthands, not required\nconfig :ash, :custom_types, uuid: AshUUID.UUID\n\n# Ash: Default belongs_to type, not required\nconfig :ash, :default_belongs_to_type, AshUUID.UUID\n```","ref":"readme.html#configuration","title":"Configuration - AshUUID","type":"extras"},{"doc":"```elixir\ndefmodule Pineapple do\n  use Ash.Resource, data_layer: AshPostgres.DataLayer, extensions: [AshUUID]\n\n  code_interface do\n    define_for Area\n  end\n\n  postgres do\n    table \"pineapples\"\n    repo MyApp.Repo\n  end\n\n  attributes do\n    uuid_attribute :id, prefix: \"pnp\"\n    create_timestamp :inserted_at\n  end\n\n  actions do\n    defaults [:create, :read, :update]\n  end\nend\n```\n\nThe full documentation can be found [on HexDocs].","ref":"readme.html#usage","title":"Usage - AshUUID","type":"extras"},{"doc":"-","ref":"readme.html#roadmap","title":"Roadmap - AshUUID","type":"extras"},{"doc":"To get set up with the development environment, you will need a Postgres\ninstance and an environment variable DATABASE_URL according to `config/config.exs`.\n\nYou may now generate and apply the test migrations:\n\n```sh\nmix ash_postgres.generate_migrations\nmix ash_postgres.create\nmix ash_postgres.migrate\nmix test\n```\n\n**AshUUID** uses `ex_check` to bundle the test configuration, and simply running\n`mix check` should closely follow the configuration used in CI.","ref":"readme.html#developing","title":"Developing - AshUUID","type":"extras"},{"doc":"If you have ideas or come across any bugs, feel free to open a [pull request] or\nan [issue]. You can also find me on the [Ash Discord](https://discord.gg/D7FNG2q) as `@moissela`.","ref":"readme.html#contributing","title":"Contributing - AshUUID","type":"extras"},{"doc":"MIT License\n\nCopyright (c) 2023 [Alessio Montagnani]\n\nSee [LICENSE.md] for details.\n\n[Alessio Montagnani]: https://github.com/moissela\n[LICENSE.md]: https://github.com/zoonect-oss/ash_uuid/blob/main/LICENSE.md\n[pull request]: https://github.com/zoonect-oss/ash_uuid/pulls\n[issue]: https://github.com/zoonect-oss/ash_uuid/issues\n[on HexDocs]: https://hexdocs.pm/ash_uuid","ref":"readme.html#license","title":"License - AshUUID","type":"extras"},{"doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v0.7.0](https://github.com/zoonect-oss/ash_uuid/compare/v0.6.0...v0.7.0) (2024-01-24)\n\n\n\n\n#","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"* better support for elixir releases through new ash_uuid otp_app name config; resolve #6; minor bugfixes; deps ugrade\n\n## [v0.6.0](https://github.com/zoonect-oss/ash_uuid/compare/v0.5.0...v0.6.0) (2023-09-19)\n\n\n\n\n#","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* add strict mode option\n\n* add support for action's arguments; resolve #5; mimor bugfixes\n\n## [v0.5.0](https://github.com/zoonect-oss/ash_uuid/compare/v0.4.0...v0.5.0) (2023-08-20)\n\n\n\n\n#","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* add supports for resources with embedded resources as attributes; resolve #4\n\n## [v0.4.0](https://github.com/zoonect-oss/ash_uuid/compare/v0.3.0...v0.4.0) (2023-08-13)\n\n\n\n\n#","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* add supports for volatile and embedded resources; resolve #3\n\n## [v0.3.0](https://github.com/zoonect-oss/ash_uuid/compare/v0.2.2...v0.3.0) (2023-08-12)\n\n\n\n\n#","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* add supports for many_to_many relationships and resources with relation to itself; resolve #1 and #2\n\n#","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* unsetting migration default for nullable fields\n\n## [v0.2.2](https://github.com/zoonect-oss/ash_uuid/compare/v0.2.1...v0.2.2) (2023-08-09)\n\n\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* update ash_postgres deps version with CustomExtension feature merged\n\n## [v0.2.1](https://github.com/zoonect-oss/ash_uuid/compare/v0.2.0...v0.2.1) (2023-08-08)\n\n\n\n\n## [v0.2.0](https://github.com/zoonect-oss/ash_uuid/compare/v0.1.0...v0.2.0) (2023-08-08)\n\n\n\n\n#","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"},{"doc":"* release preparation\n\n## [v0.1.0](https://github.com/zoonect-oss/ash_uuid/compare/v0.1.0...v0.1.0) (2023-08-08)\n\n\n\n\n#","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* structural types refactoring\n\n* adds relationships support and postgres migration_defaults through transformers and formatter plugin\n\n* postgres extension implementation\n\n* first working types\n\n#","ref":"changelog.html#features","title":"Features: - Change Log","type":"extras"},{"doc":"* better default","ref":"changelog.html#bug-fixes","title":"Bug Fixes: - Change Log","type":"extras"}]}